<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
	/**
	 * Run the migrations.
	 *
	 * @return void
	 */
	public function up()
	{
		Schema::create('user_oauth', function(Blueprint $table)
		{
			$table->id();
			$table->timestamps();
			$table->integer('site_id')->unsigned();

			$table->string('userid',128);
			$table->jsonb('oauth_data')->nullable();

			$table->integer('user_id')->unsigned()->nullable();

			$table->integer('provider_oauth_id')->unsigned();
			$table->foreign(['provider_oauth_id','site_id'])->references(['id','site_id'])->on('provider_oauth');

			$table->index(['user_id','site_id']);
			$table->foreign(['user_id','site_id'])->references(['id','site_id'])->on('users');

			$table->unique(['id','site_id']);
			$table->unique(['site_id','user_id','provider_oauth_id']);
		});
	}

	/**
	 * Reverse the migrations.
	 *
	 * @return void
	 */
	public function down()
	{
		Schema::drop('user_oauth');
	}
};